Package: koinar
Type: Package
Title: KoinaR - Remote machine learning inference using Koina
Version: 1.4.0
Authors@R: c(person(given = "Ludwig", family = "Lautenbacher",
    email = "ludwig.lautenbacher@tum.de", role = c("aut", "cre"), comment=c(ORCID="0000-0002-1540-5911")),
  person(given = "Christian", family = "Panse", email = "cp@fgcz.ethz.ch", role = c("aut"),
    comment = c(ORCID = "0000-0003-1975-3064")))
Depends: R (>= 4.3)
Imports: httr, jsonlite, methods, utils
Suggests: BiocManager, BiocStyle (>= 2.26), httptest, knitr, lattice,
        msdata, OrgMassSpecR, protViz, S4Vectors, Spectra, testthat,
        mzR
Description: A client to simplify fetching predictions from the Koina web 
  service. Koina is a model repository enabling the remote execution of models. 
  Predictions are generated as a response to HTTP/S requests, the standard protocol 
  used for nearly all web traffic.
License: Apache License 2.0
URL: https://github.com/wilhelm-lab/koina
BugReports: https://github.com/wilhelm-lab/koina/issues
Encoding: UTF-8
NeedsCompilation: no
RoxygenNote: 7.3.2
VignetteBuilder: knitr
biocViews: MassSpectrometry, Proteomics, Infrastructure, Software
git_url: https://git.bioconductor.org/packages/koinar
git_branch: RELEASE_3_22
git_last_commit: ce41812
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
Packaged: 2025-10-30 04:42:53 UTC; biocbuild
Author: Ludwig Lautenbacher [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1540-5911>),
  Christian Panse [aut] (ORCID: <https://orcid.org/0000-0003-1975-3064>)
Maintainer: Ludwig Lautenbacher <ludwig.lautenbacher@tum.de>

# KoinaR

## Introduction
Koina is a repository of machine learning models enabling the remote execution of models. Predictions are generated as a response to HTTP/S requests, the standard protocol used for nearly all web traffic. As such, HTTP/S requests can be easily generated in any programming language without requiring specialized hardware. This design enables users to easily access ML/DL models that would normally require specialized hardware from any device and in any programming language. It also means that the hardware is used more efficiently and it allows for easy horizontal scaling depending on the demand of the user base.

To minimize the barrier of entry and “democratize” access to ML models, we provide a public network of Koina instances at koina.wilhelmlab.org. The computational workload is automatically distributed to processing nodes hosted at different research institutions and spin-offs across Europe. Each processing node provides computational resources to the service network, always aiming at just-in-time results delivery.

In the spirit of open and collaborative science, we envision that this public Koina-Network can be scaled to meet the community’s needs by various research groups or institutions dedicating hardware. This can also vastly improve latency if servers are available geographically nearby. Alternatively, if data security is a concern, private instances within a local network can be easily deployed using the provided docker image.

Koina is a community driven project. It is fully open-source. We welcome all contributions and feedback! Feel free to reach out to us or open an issue on our GitHub repository.

At the moment Koina mostly focuses on the Proteomics domain but the design can be easily extended to any machine learning model. Active development to expand it into Metabolomics is underway. If you are interested in using Koina to interface with a machine learning model not currently available feel free to [create a request](https://github.com/wilhelm-lab/koina/issues).

Here we take a look at KoinaR the R package to simplify getting predictions from Koina. 

## Installation

We are currently waiting for KoinaR to be accepted into bioconductor until then you can install the package directly from github.
To do that you will need to install devtools `install.packages('devtools')`.

Install KoinaR by running `devtools::install_github('wilhelm-lab/koinar')`

## Usage

```
input <- data.frame(
  peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
  collision_energies = c(25, 25),
  precursor_charges = c(1, 2)
)

prosit2019 <- koinar::Koina(
  model_name = "Prosit_2019_intensity",
  server_url = "koina.wilhelmlab.org"
)

prediction_results <- prosit2019$predict(input)
```

## Contribute
### Setup dependencies
I recommend using the `rocker/rstudio` docker container for development.

```bash
docker run \
  -p 8888:8787 \
  -d \
  --name rstudio_server \
  -v $HOME:/workspace \
  -e PASSWORD=password \
  -e USERID=$(id -u) \
  -e GROUPID=$(id -g) \
  rocker/rstudio:latest
```

```R
install.packages(c("roxygen2", "BiocManager", "httr", "jsonlite", "rmarkdown", "testthat", "pdflatex", "protViz", "OrgMassSpecR", "httptest"))
BiocManager::install(c('BiocStyle', 'BiocCheck', 'Spectra', 'msdata', "mzR"))
```

Dependencies to build vignette with Knit
```bash
apt update
apt-get install texlive-latex-base texlive-fonts-extra mono-runtime zlib1g-dev libnetcdf19 zlib1g-dev
```

### Build documentation
Use roxygen2 to create documentation based on inline comments. 
`roxygen2::roxygenise()`.

### Run tests
We use testthat to run tests. In the `build` tab in Rstudio click on `Test`. 
Make sure you installed the package beforehand by clicking `Install` in the build tab.

### Verify code style
Verify code style according to bioconductor guidelines.
`BiocCheck::BiocCheck()`

structure(list(url = "https://google.com/v2/health/ready", status_code = 404L, 
    headers = structure(list(`content-type` = "text/html; charset=UTF-8", 
        `referrer-policy` = "no-referrer", `content-length` = "1576", 
        date = "Thu, 29 Aug 2024 13:48:15 GMT", `alt-svc` = "h3=\":443\"; ma=2592000,h3-29=\":443\"; ma=2592000"), class = c("insensitive", 
    "list")), all_headers = list(list(status = 404L, version = "HTTP/2", 
        headers = structure(list(`content-type` = "text/html; charset=UTF-8", 
            `referrer-policy` = "no-referrer", `content-length` = "1576", 
            date = "Thu, 29 Aug 2024 13:48:15 GMT", `alt-svc` = "h3=\":443\"; ma=2592000,h3-29=\":443\"; ma=2592000"), class = c("insensitive", 
        "list")))), cookies = structure(list(domain = logical(0), 
        flag = logical(0), path = logical(0), secure = logical(0), 
        expiration = structure(numeric(0), class = c("POSIXct", 
        "POSIXt")), name = logical(0), value = logical(0)), row.names = integer(0), class = "data.frame"), 
    content = charToRaw("<!DOCTYPE html>\n<html lang=en>\n  <meta charset=utf-8>\n  <meta name=viewport content=\"initial-scale=1, minimum-scale=1, width=device-width\">\n  <title>Error 404 (Not Found)!!1</title>\n  <style>\n    *{margin:0;padding:0}html,code{font:15px/22px arial,sans-serif}html{background:#fff;color:#222;padding:15px}body{margin:7% auto 0;max-width:390px;min-height:180px;padding:30px 0 15px}* > body{background:url(//www.google.com/images/errors/robot.png) 100% 5px no-repeat;padding-right:205px}p{margin:11px 0 22px;overflow:hidden}ins{color:#777;text-decoration:none}a img{border:0}@media screen and (max-width:772px){body{background:none;margin-top:0;max-width:none;padding-right:0}}#logo{background:url(//www.google.com/images/branding/googlelogo/1x/googlelogo_color_150x54dp.png) no-repeat;margin-left:-5px}@media only screen and (min-resolution:192dpi){#logo{background:url(//www.google.com/images/branding/googlelogo/2x/googlelogo_color_150x54dp.png) no-repeat 0% 0%/100% 100%;-moz-border-image:url(//www.google.com/images/branding/googlelogo/2x/googlelogo_color_150x54dp.png) 0}}@media only screen and (-webkit-min-device-pixel-ratio:2){#logo{background:url(//www.google.com/images/branding/googlelogo/2x/googlelogo_color_150x54dp.png) no-repeat;-webkit-background-size:100% 100%}}#logo{display:inline-block;height:54px;width:150px}\n  </style>\n  <a href=//www.google.com/><span id=logo aria-label=Google></span></a>\n  <p><b>404.</b> <ins>That’s an error.</ins>\n  <p>The requested URL <code>/v2/health/ready</code> was not found on this server.  <ins>That’s all we know.</ins>\n"), 
    date = structure(1724939295, class = c("POSIXct", "POSIXt"
    ), tzone = "GMT"), times = c(redirect = 0, namelookup = 0.010381, 
    connect = 0.020365, pretransfer = 0.093341, starttransfer = 0.203475, 
    total = 0.20358)), class = "response")

# R

#' Predict Results Using a Koina Model
#'
#' The `predictWithKoinaModel` function leverages the `predict` method of a `Koina` class instance to obtain model predictions based on the input data provided.
#'
#' @param koina_model An instance of the `Koina` class. This object encapsulates the model that will be used to make predictions.
#' @param input A data frame or list of arrays containing the inputs required for the model:
#'
#' @return The function returns the prediction results from the `koina_model` object. The structure of the output depends on the specific model used and the format expected by the underlying Koina prediction API.
#'
#' @examples
#' # Load the koinar package
#' library(koinar)
#'
#' # Create an instance of the Koina class with a specific model
#' prosit2019 <- koinar::Koina(
#'   model_name = "Prosit_2019_intensity",
#'   server_url = "koina.wilhelmlab.org"
#' )
#'
#' # Prepare the input data
#' input <- data.frame(
#'   peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
#'   collision_energies = c(25, 25),
#'   precursor_charges = c(1, 2)
#' )
#'
#' # Fetch the predictions by calling the predictWithKoinaModel function
#' prediction_results <- predictWithKoinaModel(prosit2019, input)
#'
#' @seealso
#' \url{https://koina.wilhelmlab.org}
#'
#' @export
predictWithKoinaModel <- function(koina_model, input) {
  return(koina_model$predict(input))
}

#' Koina client class
#'
#' @field model_name character, e.g., \code{"Prosit_2019_intensity". See https://koina.wilhelmlab.org/docs for all available models}.
#' @field url url, default is set to \code{"koina.wilhelmlab.org"}.
#' @field ssl logical.
#' @field disable_progress_bar logical.
#' @author Ludwig Lautenbacher, 2024
#'
#' @seealso \url{https://koina.wilhelmlab.org}
#'
#' @return an instance of the Koina class
#'
#' @importFrom methods new
#' @importFrom httr GET status_code content
#' @importFrom jsonlite fromJSON
#' @importFrom utils txtProgressBar
#' @export Koina
#'
#'
#' @method predict Koina
#'
#' @examples
#' library(koinar)
#' prosit2019 <- koinar::Koina(
#'   model_name = "Prosit_2019_intensity",
#'   server_url = "koina.wilhelmlab.org"
#' )
#'
#' input <- data.frame(
#'   peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
#'   collision_energies = c(25, 25),
#'   precursor_charges = c(1, 2)
#' )
#'
#' # Fetch the predictions by calling `$predict` of the model you want to use
#' prediction_results <- prosit2019$predict(input)
rbind_pad <- function(matrices) {
  # Get the maximum number of columns across all matrices
  max_cols <- max(sapply(matrices, ncol))
  
  # Create a list of padded matrices
  padded_matrices <- lapply(matrices, function(mat) {
    # Create a matrix with NA of appropriate size
    pad_mat <- matrix(NA, nrow = nrow(mat), ncol = max_cols)
    # Fill in the current matrix
    pad_mat[1:nrow(mat), 1:ncol(mat)] <- mat
    return(pad_mat)
  })
  
  # Combine padded matrices using rbind
  return(do.call(rbind, padded_matrices))
}


Koina <- setRefClass(
  "Koina",
  fields = list(
    model_inputs = "list",
    model_outputs = "list",
    batch_size = "numeric",
    response_dict = "list",
    model_name = "character",
    url = "character",
    ssl = "logical",
    type_convert = "list"
  ),
  methods = list(
    initialize = function(model_name,
                          server_url = "koina.wilhelmlab.org",
                          ssl = TRUE,
                          targets = NULL,
                          disable_progress_bar = FALSE) {
      .self$model_inputs <- list()
      .self$model_outputs <- list()
      .self$response_dict <- list()

      .self$model_name <- model_name
      .self$url <- server_url
      .self$ssl <- ssl

      .self$type_convert <- list(
        FP32 = "float32",
        BYTES = "character",
        INT16 = "integer",
        INT32 = "integer",
        INT64 = "integer"
      )

      .self$is_server_ready()
      .self$is_model_ready()

      .self$get_inputs()
      .self$get_outputs()
      .self$get_batchsize()
    },
    show = function() {
      cat("Koina Model class:\n")
      cat("\tModel name:\t", .self$model_name, "\n")
      cat("\tServer URL:\t", .self$url, "\n")
    },
    is_server_ready = function() {
      protocol <- ifelse(.self$ssl, "https", "http")
      endpoint <-
        paste0(protocol, "://", .self$url, "/v2/health/ready")
      response <- httr::GET(endpoint)
      if (httr::status_code(response) == 200) {
        return(TRUE)
      } else {
        stop(
          "Server is not ready. Response status code: ",
          httr::status_code(response)
        )
      }
    },
    is_model_ready = function() {
      protocol <- ifelse(.self$ssl, "https", "http")
      endpoint <-
        paste0(
          protocol,
          "://",
          .self$url,
          "/v2/models/",
          .self$model_name,
          "/ready"
        )
      response <- httr::GET(endpoint)

      # If the status code is 200, the model is ready.
      if (httr::status_code(response) == 200) {
        return(TRUE)
      } else {
        content <- httr::content(response, "text", encoding = "UTF-8")
        if (httr::status_code(response) == 400) {
          stop(
            "ValueError: The specified model is not available at the server. ",
            content
          )
        } else {
          stop(
            "InferenceServerException: An exception occurred while querying the server for available models. ",
            content
          )
        }
      }
    },
    get_inputs = function() {
      protocol <- ifelse(.self$ssl, "https", "http")
      endpoint <-
        paste0(protocol, "://", .self$url, "/v2/models/", .self$model_name)

      response <- httr::GET(endpoint)

      if (httr::status_code(response) != 200) {
        stop(
          "InferenceServerException: An exception occurred while querying the server for model inputs."
        )
      }

      content <- httr::content(response, "parsed")

      # Retrieve inputs from the model's metadata and store them
      if (!is.null(content$inputs)) {
        .self$model_inputs <- setNames(
          lapply(content$inputs, function(i) {
            list(shape = i$shape, datatype = i$datatype)
          }),
          vapply(content$inputs, function(i) {
            i$name
          }, c(""))
        )
      } else {
        stop(
          "InferenceServerException: Unable to retrieve model inputs from the server response."
        )
      }
    },
    get_outputs = function() {
      protocol <- ifelse(.self$ssl, "https", "http")
      endpoint <-
        paste0(protocol, "://", .self$url, "/v2/models/", .self$model_name)

      response <- httr::GET(endpoint)

      if (httr::status_code(response) != 200) {
        stop(
          "InferenceServerException: An exception occurred while querying the server for model metadata."
        )
      }

      content <- httr::content(response, "parsed")

      # Extract and store outputs from the model's metadata
      if (!is.null(content$outputs)) {
        .self$model_outputs <- setNames(
          lapply(content$outputs, function(out) {
            list(datatype = out$datatype)
          }),
          vapply(content$outputs, function(out) {
            out$name
          }, c(""))
        )
      } else {
        stop(
          "InferenceServerException: Unable to retrieve model outputs from the server response."
        )
      }
    },
    get_batchsize = function() {
      protocol <- ifelse(.self$ssl, "https", "http")
      endpoint <-
        paste0(
          protocol,
          "://",
          .self$url,
          "/v2/models/",
          .self$model_name,
          "/config"
        )

      response <- httr::GET(endpoint)

      if (httr::status_code(response) != 200) {
        stop(
          "InferenceServerException: An exception occurred while querying the server for the max batch size."
        )
      }

      content <- httr::content(response, "parsed")

      if (!is.null(content$max_batch_size)) {
        .self$batch_size <- content$max_batch_size
      } else {
        stop(
          "InferenceServerException: Unable to retrieve max batch size from the server response."
        )
      }
    },
    predict_batch = function(input_data) {
      # Check if all required inputs are provided
      required_inputs <- names(.self$model_inputs)
      missing_inputs <- setdiff(required_inputs, names(input_data))
      if (length(missing_inputs) > 0) {
        stop(
          "Missing input(s): ",
          paste(missing_inputs, collapse = ", "),
          "."
        )
      }

      # Construct the endpoint
      protocol <- ifelse(.self$ssl, "https", "http")
      endpoint <-
        paste0(
          protocol,
          "://",
          .self$url,
          "/v2/models/",
          .self$model_name,
          "/infer"
        )

      # Prepare the inputs
      inputs <- lapply(names(.self$model_inputs), function(name) {
        data_list <- input_data[[name]]
        list(
          name = name,
          shape = dim(data_list),
          # Retrieve shape from the input data
          datatype = .self$model_inputs[[name]]$datatype,
          # Retrieve datatype from the model inputs information
          data = data_list
        )
      })

      # Prepare the POST json payload
      post_data <- list(
        id = "",
        inputs = inputs
      )

      # Convert the list to JSON
      json_data <- jsonlite::toJSON(post_data, auto_unbox = TRUE)

      # Perform the POST request
      response <- httr::POST(
        url = endpoint,
        body = json_data,
        encode = "json",
        httr::add_headers(`Content-Type` = "application/json"),
        httr::timeout(60)
      )

      # Check response and return
      if (httr::status_code(response) != 200) {
        stop("Request failed. Status code: ", httr::content(response))
      } else {
        response_json <- httr::content(response, "text", encoding = "UTF-8")
        return(.self$convert_response_to_list(response_json))
      }
    },
    convert_response_to_list = function(json_response) {
      # Ensure that parsed data isn't being simplified to a vector automatically
      parsed_response <-
        jsonlite::fromJSON(json_response, simplifyVector = FALSE)

      outputs_list <- list()
      if (!is.null(parsed_response$outputs)) {
        for (output in parsed_response$outputs) {
          # Since simplifyVector = FALSE, each output should correctly be a list
          name <- output$name
          datatype <- output$datatype
          data <-
            unlist(output$data) # Unlist if data is deeply nested
          if (datatype == "FP32") {
            data <- as.numeric(data)
          } else if (datatype == "BYTES") {
            data <- as.character(data)
          } else if (datatype == "INT32") {
            data <- as.integer(data)
          }

          # Reshape the data based on provided shape TODO check if this works for higher dimensions
          if (length(output$shape) == 2) {
            data <-
              matrix(data,
                nrow = as.integer(output$shape[1]),
                byrow = TRUE
              )
          }
          outputs_list[[name]] <- data
        }
      } else {
        stop("The 'outputs' field is missing in the parsed response.")
      }

      return(outputs_list)
    },
    predict = function(input_data,
                       pred_as_df = TRUE,
                       filters = list("intensities" = c(1e-4, 1))) {
      "
      Predict using the defined model.

      Arguments:

      - input_data: Either a dataframe or a list of arrays. `names` must correspond to the inputs for the chosen model.

      - pred_as_df: Logical, indicating if the results should be returned as a dataframe (TRUE) or in the original format (FALSE).

      - filters: A list of vectors which is used to filter predictions. The key needs to equal the name of the predicted property, the first value is used as minimum the second as maximum. Ignored when `pred_as_df` == FALSE.


      Returns:

      Depending on `pred_as_df`, returns either a dataframe or a list/array of predictions, applying `min_intensity` filtering if applicable.
      "

      # Check if input_data is a dataframe and convert to a list of 1d arrays if true
      if (is.data.frame(input_data) | is(input_data, "DFrame")) {
        # Converting each column of the dataframe into a separate 2d column array and store in a list
        input_df = input_data
        input_list <- lapply(input_data, function(column) {
          # Convert to matrix with a single column (n x 1)
          array(column, dim = c(length(column), 1))
        })
      } else {
        input_list <- input_data
        input_df = data.frame(input_data)
      }

      total_samples <- dim(input_list[[1]])[1]
      num_batches <- ceiling(total_samples / .self$batch_size)

      #  Initialize progress bar
      if (interactive()) {
        pb <- txtProgressBar(min = 0, max = num_batches, style = 3)
      }

      results <- list()

      results <- lapply(seq_len(num_batches), function(batch_number) {
        start_idx <- (batch_number - 1) * .self$batch_size + 1
        end_idx <- min(batch_number * .self$batch_size, total_samples)

        # Preparing batch_data
        batch_data <- lapply(input_list, function(arr) {
          # For arrays, slice while preserving dimensional integrity
          arr[start_idx:end_idx, , drop = FALSE]
        })

        result <- .self$predict_batch(batch_data)

        # Update progress bar
        if (interactive()) {
          setTxtProgressBar(pb, batch_number)
        }

        result
      })

      if (interactive()) {
        close(pb)
      }

      results <- aggregate_batches(results)

      if (pred_as_df) {
        return(format_predictions(results, input_df, filters))
      } else {
        return(results)
      }
    },
    aggregate_batches = function(list_of_list_of_arrays) {
      aggregated_results <- list()

      # Extract names from the first batch as a reference for aggregation
      reference_names <- names(list_of_list_of_arrays[[1]])

      # Loop over each name to aggregate across batches
      aggregated_results <- lapply(reference_names, function(name) {
        # Extract elements for the current name from all batches
        elements <- lapply(list_of_list_of_arrays, function(batch) batch[[name]])

        # Determine whether elements are vectors or matrices
        if (is.matrix(elements[[1]])) {
          # Use rbind to concatenate matrices along the first axis
          return(rbind_pad(elements))
        } else {
          # For vectors, concatenate directly and preserve as a matrix for consistency
          concatenated_vector <- do.call(c, elements)
          # Convert to a column matrix, assuming vectors are considered as 1-column matrices
          return(matrix(concatenated_vector, ncol = 1))
        }
      })

      # Set names for the aggregated results
      names(aggregated_results) <- reference_names
      return(aggregated_results)
    },
    format_predictions = function(predictions, input_df, filters = list("intensities" = c(1e-4, 1))) {
      # Use lapply to flatten each 2D array in the list to a 1D vector
      df <-
        data.frame(lapply(predictions, function(array) {
          as.vector(t(array))
        }))
      # Flatten the predictions if the second dimension is larger than 1
      if(any(sapply(predictions, function(x) {dim(x)[2] > 1}))){
        df <-
          cbind(input_df[rep(seq_len(nrow(input_df)), each = dim(predictions$intensities)[2]), ], df)
      }
      
      for(name in names(filters)){
        if (!is.null(df[[name]])){
          df <- df[(df[[name]] >= filters[[name]][1]) & (df[[name]] <= filters[[name]][2]), ]
        }
      }
      
      if(is(input_df, "DFrame")){
        df <- S4Vectors::DataFrame(df)
      }
      return(df)
    }
  )
)

# R
bloat_array <- function(arr, n) {
  # Determine the new dimensions, repeating the first dimension `n` times
  new_dim <- dim(arr)
  new_dim[1] <- new_dim[1] * n
  # Create an expanded array
  expanded_array <- array(rep(arr, n), dim = new_dim)
  return(expanded_array)
}

with_mock_dir("mAPI_fig1", {
  test_that("check Prosit2019 Fig1", {
    ## input
    peptide <- "LKEATIQLDELNQK"
    peptide_n <- nchar(peptide) - 1

    ## indices of top 10 highest intensities
    ground_truth <- c(31, 13, 25, 52, 34, 43, 37, 46, 40, 58)

    koina_instance <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org",
      ssl = TRUE
    )

    koina_instance_fgcz <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "dlomix.fgcz.uzh.ch:443",
      ssl = TRUE
    )

    input <- list(
      peptide_sequences = array(c(peptide),
        dim = c(1, 1)
      ),
      collision_energies = array(c(25), dim = c(1, 1)),
      precursor_charges = array(c(1), dim = c(1, 1))
    )

    prediction_results <-
      koina_instance$predict(input, pred_as_df = FALSE, filters = list("intensities" = c(0, 1)) )

    ## determine indices of top 10 highest intensities
    (prediction_results$intensities |> order(decreasing = TRUE))[seq(1, 10)] -> idx

    testthat::expect_equal(idx, ground_truth)

    prediction_results_fgcz <-
      koina_instance_fgcz$predict(input, pred_as_df = FALSE, filters = list("intensities" = c(0, 1)))
    ## determine indices of top 10 highest intensities
    (prediction_results_fgcz$intensities |> order(decreasing = TRUE))[seq(1, 10)] -> idx_fgcz

    testthat::expect_equal(idx_fgcz, ground_truth)

    ## check y-fragmention annotation
    testthat::expect_equal(protViz::fragmentIon(peptide)[[1]]$y[seq(1, peptide_n)],
      prediction_results$mz[seq(1, 174, by = 6)][seq(1, peptide_n)],
      tolerance = 1.0e-04
    )

    testthat::expect_equal(protViz::fragmentIon(peptide)[[1]]$y[seq(1, peptide_n)],
      prediction_results_fgcz$mz[seq(1, 174, by = 6)][seq(1, peptide_n)],
      tolerance = 1.0e-04
    )
  })
})

with_mock_dir("mAPI_wrong_url", {
  test_that("Check error: Server unavailable", {
    expect_error(
      koinar::Koina(
        model_name = "Prosit_2019_intensity",
        server_url = "google.com",
      ),
      "Server is not ready. Response status code: 404"
    )
  })
})

with_mock_dir("mAPI_wrong_model", {
  test_that("Check error: Model unavailable", {
    expect_error(
      koinar::Koina(model_name = "not_a_valid_model_name"),
      "ValueError: The specified model is not available at the server. "
    )
  })
})

with_mock_dir("mAPI_wrong_input", {
  test_that("Check error: Missing input", {
    koina_instance <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org",
      ssl = TRUE
    )


    input <- list(
      peptide_sequence = array(c("LKEATIQLDELNQK"),
        dim = c(1, 1)
      ),
      collision_energies = array(c(25), dim = c(1, 1)),
      precursor_charges = array(c(1), dim = c(1, 1))
    )

    expect_error(
      koina_instance$predict(input),
      "Missing input\\(s\\): peptide_sequences."
    )
  })
})

with_mock_dir("mAPI_batch", {
  test_that("Check batching", {
    koina_instance <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org",
      ssl = TRUE
    )

    input_data <- list(
      peptide_sequences = array(c("LKEATIQLDELNQK"),
        dim = c(1, 1)
      ),
      collision_energies = array(c(25), dim = c(1, 1)),
      precursor_charges = array(c(1), dim = c(1, 1))
    )
    large_input_data <- lapply(input_data, bloat_array, 1234)

    predictions <- koina_instance$predict(large_input_data, pred_as_df = FALSE)

    expect_equal(dim(predictions[["intensities"]]), c(1234, 174))
  })
})

with_mock_dir("mAPI_df_input", {
  test_that("Check data.frame input", {
    koina_instance <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org",
      ssl = TRUE
    )

    input_data <- list(
      peptide_sequences = array(c("LKEATIQLDELNQK"),
        dim = c(1, 1)
      ),
      collision_energies = array(c(25), dim = c(1, 1)),
      precursor_charges = array(c(1), dim = c(1, 1))
    )

    df_input <- data.frame(input_data)
    pred_df <- koina_instance$predict(df_input, pred_as_df = FALSE)
    pred_arr <- koina_instance$predict(input_data, pred_as_df = FALSE)

    expect_equal(pred_df[["intensities"]], pred_arr[["intensities"]], 1e-5)
  })
})

with_mock_dir("mAPI_s4_df_input", {
  test_that("Check DataFrame input", {
    koina_instance <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org",
      ssl = TRUE
    )

    input_data <- list(
      peptide_sequences = array(c("LKEATIQLDELNQK"),
        dim = c(1, 1)
      ),
      collision_energies = array(c(25), dim = c(1, 1)),
      precursor_charges = array(c(1), dim = c(1, 1))
    )

    DataFrame_input <- S4Vectors::DataFrame(input_data)
    colnames(DataFrame_input) <- sapply(strsplit(colnames(DataFrame_input), ".", fixed = TRUE), function(x) {
      x[1]
    }) # Fix columnnames

    df_input <- data.frame(input_data)

    pred_d.f <- koina_instance$predict(df_input, pred_as_df = FALSE)
    pred_DF <- koina_instance$predict(DataFrame_input, pred_as_df = FALSE)

    expect_equal(pred_d.f[["intensities"]], pred_DF[["intensities"]], 1e-5)
  })
})

with_mock_dir("mAPI_df_output", {
  test_that("Check dataframe output", {
    koina_instance <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org",
      ssl = TRUE
    )

    input_data <- list(
      peptide_sequences = array(c("LKEATIQLDELNQK"),
        dim = c(1, 1)
      ),
      collision_energies = array(c(25), dim = c(1, 1)),
      precursor_charges = array(c(1), dim = c(1, 1))
    )

    df_input <- data.frame(input_data)
    predictions <- koina_instance$predict(df_input, filters = list("intensities" = c(0.1, 1)))

    expect_equal(nrow(predictions), 19)
    expect_equal(class(predictions)[1], "data.frame")
  })
})

with_mock_dir("mAPI_s4_df_output", {
  test_that("Check S4 DF output", {
    koina_instance <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org",
      ssl = TRUE
    )
    
    input_data <- list(
      peptide_sequences = array(c("LKEATIQLDELNQK"),
                                dim = c(1, 1)
      ),
      collision_energies = array(c(25), dim = c(1, 1)),
      precursor_charges = array(c(1), dim = c(1, 1))
    )
    
    DataFrame_input <- S4Vectors::DataFrame(input_data)
    colnames(DataFrame_input) <- sapply(strsplit(colnames(DataFrame_input), ".", fixed = TRUE), function(x) {
      x[1]
    }) # Fix columnnames
    predictions <- koina_instance$predict(DataFrame_input, filters = list("intensities" = c(0.1, 1)))
    
    expect_equal(nrow(predictions), 19)
    expect_equal(class(predictions)[1], "DFrame")
  })
})

with_mock_dir("mAPI_altPred", {
  test_that("predictWithKoinaModel", {
    prosit2019 <- koinar::Koina(
      model_name = "Prosit_2019_intensity",
      server_url = "koina.wilhelmlab.org"
    )

    input <- data.frame(
      peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
      collision_energies = c(25, 25),
      precursor_charges = c(1, 2)
    )

    p1 <- prosit2019$predict(input)
    p2 <- koinar::predictWithKoinaModel(prosit2019, input)

    expect_equal(p1, p2, 1e-6)
  })
})

with_mock_dir("mAPI_matrixpad", {
  test_that("predictFlexMatrixBatch", {
    model <- koinar::Koina(
      model_name = "AlphaPeptDeep_ms2_generic",
      server_url = "koina.wilhelmlab.org"
    )
    batch_size <- model$batch_size
    
    input <- data.frame(
      peptide_sequences = c(rep("PEPTIDE", batch_size), rep("PEPTIDEPEPTIDE", batch_size)),
      collision_energies = rep(25, 2 * batch_size),
      precursor_charges = rep(2, 2 * batch_size),
      instrument_types = rep("LUMOS", 2 * batch_size)
    )
    
    data = model$predict(input, pred_as_df = FALSE)
    
    expect_equal(sum(is.na(data$annotation[1,])), 28)
    expect_equal(sum(is.na(data$annotation[1001,])), 0)
  })
})

structure(list(url = "https://koina.wilhelmlab.org/v2/models/not_a_valid_model_name/ready", 
    status_code = 400L, headers = structure(list(server = "nginx/1.24.0 (Ubuntu)", 
        date = "Thu, 29 Aug 2024 13:48:15 GMT", `content-type` = "text/plain", 
        `content-length` = "0", `x-powered-by` = "Express"), class = c("insensitive", 
    "list")), all_headers = list(list(status = 400L, version = "HTTP/2", 
        headers = structure(list(server = "nginx/1.24.0 (Ubuntu)", 
            date = "Thu, 29 Aug 2024 13:48:15 GMT", `content-type` = "text/plain", 
            `content-length` = "0", `x-powered-by` = "Express"), class = c("insensitive", 
        "list")))), cookies = structure(list(domain = logical(0), 
        flag = logical(0), path = logical(0), secure = logical(0), 
        expiration = structure(numeric(0), class = c("POSIXct", 
        "POSIXt")), name = logical(0), value = logical(0)), row.names = integer(0), class = "data.frame"), 
    content = charToRaw(""), date = structure(1724939295, class = c("POSIXct", 
    "POSIXt"), tzone = "GMT"), times = c(redirect = 0, namelookup = 3.4e-05, 
    connect = 3.4e-05, pretransfer = 0.000147, starttransfer = 0.003296, 
    total = 0.003317)), class = "response")

## ----style, results = 'asis', echo=FALSE, message=FALSE-----------------------
# Configuration of the vignette
BiocStyle::markdown()
knitr::opts_chunk$set(fig.wide = TRUE, fig.retina = 3, error = FALSE, eval = TRUE)

# httptest is used to cached responses
# This is important to compile the vignette in a CI pipeline
# If you want to use this vignette interactively you can delete this part
library(httptest)
start_vignette("mAPI")
set_requester(function(request) {
  request <- gsub_request(request, "koina.wilhelmlab.org", "k.w.org")
  request <- gsub_request(request, "dlomix.fgcz.uzh.ch", "d.f.u.ch")
  request <- gsub_request(request, "Prosit_2019_intensity", "P_29_int")
})

## ----eval=FALSE---------------------------------------------------------------
# if (!require("BiocManager", quietly = TRUE)) {
#   install.packages("BiocManager")
# }
# 
# BiocManager::install("koinar")

## ----create, eval=TRUE, message=FALSE-----------------------------------------
# Create a client tied to a specific server & model
# Here we use the model published by Gessulat et al [@prosit2019]
# And the public server available at koina.wilhelmlab.org
# All available models can be found at https://koina.wilhelmlab.org/docs
prosit2019 <- koinar::Koina(
  model_name = "Prosit_2019_intensity",
  server_url = "koina.wilhelmlab.org"
)
prosit2019

## ----input, message=FALSE-----------------------------------------------------
# Create example inputs
# Here we look at two different peptide sequences with charge 1 and 2 respectively
input <- data.frame(
  peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
  collision_energies = c(25, 25),
  precursor_charges = c(1, 2)
)

## -----------------------------------------------------------------------------
# Fetch the predictions by calling `$predict` of the model you want to use
# A progress bar shows you how much of the predictions are already done
# In this case this should complete instantly
prediction_results <- prosit2019$predict(input)

# Display the predictions
# The output varies depending on the chosen model
# For the intenstiy model we get a data.frame with 5 columns
# The three inputs we provided: peptide_sequences, collision_energies, precursor_charges
# and for each predicted fragment ion: annotation, mz, intensities
head(prediction_results)

## -----------------------------------------------------------------------------
prediction_results <- koinar::predictWithKoinaModel(prosit2019, input)

## ----Fig1, echo=FALSE, out.width="100%", eval=TRUE, fig.cap="Screenshot of Fig.1d [@prosit2019] https://www.nature.com/articles/s41592-019-0426-7", message=FALSE----
knitr::include_graphics("https://user-images.githubusercontent.com/4901987/237583247-a948ceb3-b525-4c30-b701-218346a30cf6.jpg")

## ----Fig2, out.width="100%", fig.cap="LKEATIQLDELNQK CE35 3+; Reproducing Fig1", fig.height=8, fig.retina=3, message=FALSE----
input <- data.frame(
  peptide_sequences = c("LKEATIQLDELNQK"),
  collision_energies = c(35),
  precursor_charges = c(3)
)

## -----------------------------------------------------------------------------
prediction_results <- prosit2019$predict(input)

## -----------------------------------------------------------------------------
prediction_results <- prosit2019$predict(input)

# Plot the spectrum
plot(prediction_results$intensities ~ prediction_results$mz,
  type = "n",
  ylim = c(0, 1.1)
)
yIdx <- grepl("y", prediction_results$annotation)
points(prediction_results$mz[yIdx], prediction_results$intensities[yIdx],
  col = "red", type = "h", lwd = 2
)
points(prediction_results$mz[!yIdx], prediction_results$intensities[!yIdx],
  col = "blue", type = "h", lwd = 2
)

text(prediction_results$mz, prediction_results$intensities,
  labels = prediction_results$annotation,
  las = 2, cex = 1, pos = 3
)

## ----defineBiognosysIrtPeptides, message=FALSE--------------------------------
input <- data.frame(
  peptide_sequences = c(
    "LGGNEQVTR", "YILAGVENSK", "GTFIIDPGGVIR", "GTFIIDPAAVIR",
    "GAGSSEPVTGLDAK", "TPVISGGPYEYR", "VEATFGVDESNAK",
    "TPVITGAPYEYR", "DGLDAASYYAPVR", "ADVTPADFSEWSK",
    "LFLQFGAQGSPFLK"
  ),
  collision_energies = 35,
  precursor_charges = 2
)

## ----AlphaPept, message=FALSE-------------------------------------------------
pred_prosit <- prosit2019$predict((input))
pred_prosit$model <- "Prosit_2019_intensity"

ms2pip <- koinar::Koina(
  model_name = "ms2pip_HCD2021",
  server_url = "koina.wilhelmlab.org"
)

pred_ms2pip <- ms2pip$predict(input)
pred_ms2pip$model <- "ms2pip_HCD2021"

## ----xyplot, out.width="100%", fig.cap="iRT peptides fragment ions prediction using  AlphaPept and Prosit_intensity_2019", fig.height=15, fig.retina=3----
lattice::xyplot(intensities ~ mz | model * peptide_sequences,
  group = grepl("y", annotation),
  data = rbind(
    pred_prosit[, names(pred_ms2pip)],
    pred_ms2pip
  ),
  type = "h"
)

## ----mssimplot, out.width="100%", fig.cap="Spectral similarity ms2pip vs prosit plot created with OrgMassSpecR", message=FALSE----
peptide_sequence <- "ADVTPADFSEWSK"

sim <- OrgMassSpecR::SpectrumSimilarity(pred_prosit[pred_prosit$peptide_sequences == peptide_sequence, c("mz", "intensities")],
  pred_ms2pip[pred_ms2pip$peptide_sequences == peptide_sequence, c("mz", "intensities")],
  top.lab = "Prosit",
  bottom.lab = "MS2PIP",
  b = 25
)
title(main = paste(peptide_sequence, "| Spectrum similarity", round(sim, 3)))

## ----message=FALSE------------------------------------------------------------
library(Spectra)
library(msdata)

fls <- c(
  system.file("proteomics",
    "TMT_Erwinia_1uLSike_Top10HCD_isol2_45stepped_60min_01-20141210.mzML.gz",
    package = "msdata"
  )
)

data <- Spectra(fls, source = MsBackendMzR())
data <- filterMsLevel(data, msLevel = 2) # Filter raw data for fragment ion spectra only

metadata <- spectraData(data) # Extract metadata
spectra <- peaksData(data) # Extract spectra data

## -----------------------------------------------------------------------------
# Sort data by precursor mass since Mascot-queries are sorted by mass
metadata$mass <- (metadata$precursorMz * metadata$precursorCharge)
peptide_mass_order <- order(metadata$mass)
metadata <- metadata[peptide_mass_order, ]
sorted_spectra <- spectra[peptide_mass_order]

## -----------------------------------------------------------------------------
input <- data.frame(
  peptide_sequences = c("[UNIMOD:737]-AAVEEGVVAGGGVALIR"),
  collision_energies = c(45),
  precursor_charges = c(3),
  fragmentation_types = c("HCD")
)
prosit <- koinar::Koina("Prosit_2020_intensity_TMT")
pred_prosit <- prosit$predict(input)

## -----------------------------------------------------------------------------
sim <- OrgMassSpecR::SpectrumSimilarity(sorted_spectra[[4128]],
  pred_prosit[, c("mz", "intensities")],
  top.lab = "Experimental",
  bottom.lab = "Prosit",
  t = 0.01
)
title(main = paste("Spectrum similarity", round(sim, 3)))

## ----sessioninfo, eval=TRUE---------------------------------------------------
sessionInfo()

library(httptest)
unzip("mAPI_batch.zip")
set_requester(function(request) {
  request <- gsub_request(request, "koina.wilhelmlab.org", "k.w.org")
  request <- gsub_request(request, "dlomix.fgcz.uzh.ch", "d.f.u.ch")
  request <- gsub_request(request, "Prosit_2019_intensity", "P_29_int")
})

---
title: "Using R client for Koina"
author:
- name: Ludwig Lautenbacher
  affiliation:
    - Computational Mass Spectrometry, Technical University of Munich (TUM), Freising, Germany
  email: ludwig.lautenbacher@tum.de
- name: Christian Panse
  affiliation:
    - Functional Genomics Center Zurich (FGCZ) - University of Zurich | ETH Zurich, Winterthurerstrasse 190, CH-8057 Zurich, Switzerland
    - Swiss Institute of Bioinformatics (SIB), Quartier Sorge - Batiment Amphipole, CH-1015 Lausanne, Switzerland
package: koinar
abstract: |
  How to use `r BiocStyle::Biocpkg('KoinaR')` to fetch predictions from [Koina](https://koina.wilhelmlab.org/)
output:
  BiocStyle::html_document:
    toc_float: true
bibliography: koina.bib
vignette: >
  %\usepackage[utf8]{inputenc}
  %\VignetteIndexEntry{On using the R lang client for koina}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
urlcolor: blue
---

```{r style, results = 'asis', echo=FALSE, message=FALSE}
# Configuration of the vignette
BiocStyle::markdown()
knitr::opts_chunk$set(fig.wide = TRUE, fig.retina = 3, error = FALSE, eval = TRUE)

# httptest is used to cached responses
# This is important to compile the vignette in a CI pipeline
# If you want to use this vignette interactively you can delete this part
library(httptest)
start_vignette("mAPI")
set_requester(function(request) {
  request <- gsub_request(request, "koina.wilhelmlab.org", "k.w.org")
  request <- gsub_request(request, "dlomix.fgcz.uzh.ch", "d.f.u.ch")
  request <- gsub_request(request, "Prosit_2019_intensity", "P_29_int")
})
```

# Introduction
Koina is a repository of machine learning models enabling the remote execution of models. Predictions are generated as a response to HTTP/S requests, the standard protocol used for nearly all web traffic. As such, HTTP/S requests can be easily generated in any programming language without requiring specialized hardware. This design enables users to easily access ML/DL models that would normally require specialized hardware from any device and in any programming language. It also means that the hardware is used more efficiently and it allows for easy horizontal scaling depending on the demand of the user base.

To minimize the barrier of entry and “democratize” access to ML models, we provide a public network of Koina instances at koina.wilhelmlab.org. The computational workload is automatically distributed to processing nodes hosted at different research institutions and spin-offs across Europe. Each processing node provides computational resources to the service network, always aiming at just-in-time results delivery.

In the spirit of open and collaborative science, we envision that this public Koina-Network can be scaled to meet the community’s needs by various research groups or institutions dedicating hardware. This can also vastly improve latency if servers are available geographically nearby. Alternatively, if data security is a concern, private instances within a local network can be easily deployed using the provided docker image.

Koina is a community driven project. It is fully open-source. We welcome all contributions and feedback! Feel free to reach out to us or open an issue on our GitHub repository.

At the moment Koina mostly focuses on the Proteomics domain but the design can be easily extended to any machine learning model. Active development to expand it into Metabolomics is underway. If you are interested in using Koina to interface with a machine learning model not currently available feel free to [create a request](https://github.com/wilhelm-lab/koina/issues).

Here we take a look at KoinaR the R package to simplify getting predictions from Koina. 

# Install
```{r, eval=FALSE}
if (!require("BiocManager", quietly = TRUE)) {
  install.packages("BiocManager")
}

BiocManager::install("koinar")
```


# Basic usage
Here we show the basic usage principles of KoinaR. The first step to interact with Koina is to pick a model and server you wish to use.
Here we use the model Prosit_2019_intensity published by Gessulat et al [@prosit2019] and the public Koina network available via koina.wilhelmlab.org.
For a complete overview of models available on Koina have a look at the documentation available at https://koina.wilhelmlab.org/docs. 

```{r create, eval=TRUE, message=FALSE}
# Create a client tied to a specific server & model
# Here we use the model published by Gessulat et al [@prosit2019]
# And the public server available at koina.wilhelmlab.org
# All available models can be found at https://koina.wilhelmlab.org/docs
prosit2019 <- koinar::Koina(
  model_name = "Prosit_2019_intensity",
  server_url = "koina.wilhelmlab.org"
)
prosit2019
```

After you created the model you need to prepare your inputs. Here we prepare a simple data.frame with three different inputs 
`peptide_sequences`, `collision_energies`, and `precursor_charges`.

```{r input, message=FALSE}
# Create example inputs
# Here we look at two different peptide sequences with charge 1 and 2 respectively
input <- data.frame(
  peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
  collision_energies = c(25, 25),
  precursor_charges = c(1, 2)
)
```

After preparing the input you can start predicting by calling `prosit2019$predict(input)`.
```{r}
# Fetch the predictions by calling `$predict` of the model you want to use
# A progress bar shows you how much of the predictions are already done
# In this case this should complete instantly
prediction_results <- prosit2019$predict(input)

# Display the predictions
# The output varies depending on the chosen model
# For the intenstiy model we get a data.frame with 5 columns
# The three inputs we provided: peptide_sequences, collision_energies, precursor_charges
# and for each predicted fragment ion: annotation, mz, intensities
head(prediction_results)
```

Alternatively if you prefer pass by value semantic you can use the `predictWithKoinaModel` function to predict with a Koina model.
```{r}
prediction_results <- koinar::predictWithKoinaModel(prosit2019, input)
```

# Example 1: Reproducing Fig.1d from [@prosit2019]
One common use case for most of the models available through Koina is the prediction
of peptide properties to improve peptide identification rates in Proteomics experiments.
One of the properties that is most beneficial in this context is the peptide fragment intensity pattern. 

In this example we have a look at the model published by Gessulat et al [@prosit2019] and attempt to reproduce a figure 1d published in the manuscript.
In this Figure the authors exemplify the prediction accuracy of their model by comparing the experimentally aquired mass spectra with the predictions of their model.

```{r Fig1, echo=FALSE, out.width="100%", eval=TRUE, fig.cap="Screenshot of Fig.1d [@prosit2019] https://www.nature.com/articles/s41592-019-0426-7", message=FALSE}
knitr::include_graphics("https://user-images.githubusercontent.com/4901987/237583247-a948ceb3-b525-4c30-b701-218346a30cf6.jpg")
```

We prepare the inputs for the model, all of them can be found in the header of the figure.

```{r Fig2, out.width="100%", fig.cap="LKEATIQLDELNQK CE35 3+; Reproducing Fig1", fig.height=8, fig.retina=3, message=FALSE}
input <- data.frame(
  peptide_sequences = c("LKEATIQLDELNQK"),
  collision_energies = c(35),
  precursor_charges = c(3)
)
```

We reuse the model instance (`prosit2019`) created in the previous chapter. 
To fetch the predictions we call the `predict` method of the model instance.
```{r}
prediction_results <- prosit2019$predict(input)
```


Here we create a simple mass spectrum to visually compare against Figure 1d of Gessulat et al [@prosit2019].
We can see that the predicted spectrum we just generated is identical to the predicted spectrum shown in the publication. 
```{r}
prediction_results <- prosit2019$predict(input)

# Plot the spectrum
plot(prediction_results$intensities ~ prediction_results$mz,
  type = "n",
  ylim = c(0, 1.1)
)
yIdx <- grepl("y", prediction_results$annotation)
points(prediction_results$mz[yIdx], prediction_results$intensities[yIdx],
  col = "red", type = "h", lwd = 2
)
points(prediction_results$mz[!yIdx], prediction_results$intensities[!yIdx],
  col = "blue", type = "h", lwd = 2
)

text(prediction_results$mz, prediction_results$intensities,
  labels = prediction_results$annotation,
  las = 2, cex = 1, pos = 3
)
```

 Example 2: Compare spectral similarity between models

Fragment ion prediction models can have major difference in the predictions they generate.
Impacting the peptide identification performance. We show this here by predicting the Biognosys iRT peptides, 
a commonly used set of synthetic spike in reference peptides, with the Prosit_intensity_2019 and the ms2pip_2021HCD models. 

We follow the same steps as before.(1) Prepare the input.

```{r defineBiognosysIrtPeptides, message=FALSE}
input <- data.frame(
  peptide_sequences = c(
    "LGGNEQVTR", "YILAGVENSK", "GTFIIDPGGVIR", "GTFIIDPAAVIR",
    "GAGSSEPVTGLDAK", "TPVISGGPYEYR", "VEATFGVDESNAK",
    "TPVITGAPYEYR", "DGLDAASYYAPVR", "ADVTPADFSEWSK",
    "LFLQFGAQGSPFLK"
  ),
  collision_energies = 35,
  precursor_charges = 2
)
```

(2) Predict

```{r AlphaPept, message=FALSE}
pred_prosit <- prosit2019$predict((input))
pred_prosit$model <- "Prosit_2019_intensity"

ms2pip <- koinar::Koina(
  model_name = "ms2pip_HCD2021",
  server_url = "koina.wilhelmlab.org"
)

pred_ms2pip <- ms2pip$predict(input)
pred_ms2pip$model <- "ms2pip_HCD2021"
```

After generating the plots for all iRT peptides we can observe that the predicted mass spectra are quite different.
Which model is better depends on the data set that is being analyzed.

```{r xyplot, out.width="100%", fig.cap="iRT peptides fragment ions prediction using  AlphaPept and Prosit_intensity_2019", fig.height=15, fig.retina=3}
lattice::xyplot(intensities ~ mz | model * peptide_sequences,
  group = grepl("y", annotation),
  data = rbind(
    pred_prosit[, names(pred_ms2pip)],
    pred_ms2pip
  ),
  type = "h"
)
```

We can also use the `OrgMassSpecR` package to generate a mirror spectrum using the `SpectrumSimilarity` function.
This not only provides a better visualization to compare spectra but also calculates a similarity score.

```{r mssimplot, out.width="100%", fig.cap="Spectral similarity ms2pip vs prosit plot created with OrgMassSpecR", message=FALSE}
peptide_sequence <- "ADVTPADFSEWSK"

sim <- OrgMassSpecR::SpectrumSimilarity(pred_prosit[pred_prosit$peptide_sequences == peptide_sequence, c("mz", "intensities")],
  pred_ms2pip[pred_ms2pip$peptide_sequences == peptide_sequence, c("mz", "intensities")],
  top.lab = "Prosit",
  bottom.lab = "MS2PIP",
  b = 25
)
title(main = paste(peptide_sequence, "| Spectrum similarity", round(sim, 3)))
```

# Example 3: Loading rawdata with the Spectra package

The main application of predicted fragment mass spectra is to be compared with experimental spectra.
Here we use the `Spectra` package to read a rawfile (provided by the `msdata` package).

```{r, message=FALSE}
library(Spectra)
library(msdata)

fls <- c(
  system.file("proteomics",
    "TMT_Erwinia_1uLSike_Top10HCD_isol2_45stepped_60min_01-20141210.mzML.gz",
    package = "msdata"
  )
)

data <- Spectra(fls, source = MsBackendMzR())
data <- filterMsLevel(data, msLevel = 2) # Filter raw data for fragment ion spectra only

metadata <- spectraData(data) # Extract metadata
spectra <- peaksData(data) # Extract spectra data
```

The data we are using was searched using Mascot to map spectra to Mascot-queries we need to sort the Spectra by precursor MZ. 

```{r}
# Sort data by precursor mass since Mascot-queries are sorted by mass
metadata$mass <- (metadata$precursorMz * metadata$precursorCharge)
peptide_mass_order <- order(metadata$mass)
metadata <- metadata[peptide_mass_order, ]
sorted_spectra <- spectra[peptide_mass_order]
```

Once we sorted the data we can find the corresponding identification in this file on [Pride](https://ftp.pride.ebi.ac.uk/pride/data/archive/2012/03/PXD000001/F063721.dat).
To illustrate the workflow we pick the random Spectrum 4128.
Searching for `q4128` in the Pride file gives us the `peptide_sequence` (`[UNIMOD:737]-AAVEEGVVAGGGVALIR`) and `precursor_charge` (`3`) Mascot identified.
To validate the identification we fetch predictions from Koina using the `Prosit_2020_intensity_TMT` model.

```{r}
input <- data.frame(
  peptide_sequences = c("[UNIMOD:737]-AAVEEGVVAGGGVALIR"),
  collision_energies = c(45),
  precursor_charges = c(3),
  fragmentation_types = c("HCD")
)
prosit <- koinar::Koina("Prosit_2020_intensity_TMT")
pred_prosit <- prosit$predict(input)
```

We use `SpectrumSimilarity` from `OrgMassSpecR` to visualize the spectrum and get a similarity score to the prediction.
We can observe high agreement between the experimental and predicted spectrum. Validating this identification.

```{r}
sim <- OrgMassSpecR::SpectrumSimilarity(sorted_spectra[[4128]],
  pred_prosit[, c("mz", "intensities")],
  top.lab = "Experimental",
  bottom.lab = "Prosit",
  t = 0.01
)
title(main = paste("Spectrum similarity", round(sim, 3)))
```

# References {-}

# Session information {-}
```{r sessioninfo, eval=TRUE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Koina-class.R
\docType{class}
\name{Koina-class}
\alias{Koina-class}
\alias{Koina}
\title{Koina client class}
\value{
an instance of the Koina class
}
\description{
Koina client class
}
\section{Fields}{

\describe{
\item{\code{model_name}}{character, e.g., \code{"Prosit_2019_intensity". See https://koina.wilhelmlab.org/docs for all available models}.}

\item{\code{url}}{url, default is set to \code{"koina.wilhelmlab.org"}.}

\item{\code{ssl}}{logical.}

\item{\code{disable_progress_bar}}{logical.}
}}

\section{Methods}{

\describe{
\item{\code{predict(
  input_data,
  pred_as_df = TRUE,
  filters = list(intensities = c(1e-04, 1))
)}}{      Predict using the defined model.

      Arguments:

      - input_data: Either a dataframe or a list of arrays. `names` must correspond to the inputs for the chosen model.

      - pred_as_df: Logical, indicating if the results should be returned as a dataframe (TRUE) or in the original format (FALSE).

      - filters: A list of vectors which is used to filter predictions. The key needs to equal the name of the predicted property, the first value is used as minimum the second as maximum. Ignored when `pred_as_df` == FALSE.


      Returns:

      Depending on `pred_as_df`, returns either a dataframe or a list/array of predictions, applying `min_intensity` filtering if applicable.
      }
}}

\examples{
library(koinar)
prosit2019 <- koinar::Koina(
  model_name = "Prosit_2019_intensity",
  server_url = "koina.wilhelmlab.org"
)

input <- data.frame(
  peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
  collision_energies = c(25, 25),
  precursor_charges = c(1, 2)
)

# Fetch the predictions by calling `$predict` of the model you want to use
prediction_results <- prosit2019$predict(input)
}
\seealso{
\url{https://koina.wilhelmlab.org}
}
\author{
Ludwig Lautenbacher, 2024
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Koina-class.R
\name{predictWithKoinaModel}
\alias{predictWithKoinaModel}
\title{Predict Results Using a Koina Model}
\usage{
predictWithKoinaModel(koina_model, input)
}
\arguments{
\item{koina_model}{An instance of the `Koina` class. This object encapsulates the model that will be used to make predictions.}

\item{input}{A data frame or list of arrays containing the inputs required for the model:}
}
\value{
The function returns the prediction results from the `koina_model` object. The structure of the output depends on the specific model used and the format expected by the underlying Koina prediction API.
}
\description{
The `predictWithKoinaModel` function leverages the `predict` method of a `Koina` class instance to obtain model predictions based on the input data provided.
}
\examples{
# Load the koinar package
library(koinar)

# Create an instance of the Koina class with a specific model
prosit2019 <- koinar::Koina(
  model_name = "Prosit_2019_intensity",
  server_url = "koina.wilhelmlab.org"
)

# Prepare the input data
input <- data.frame(
  peptide_sequences = c("LGGNEQVTR", "GAGSSEPVTGLDAK"),
  collision_energies = c(25, 25),
  precursor_charges = c(1, 2)
)

# Fetch the predictions by calling the predictWithKoinaModel function
prediction_results <- predictWithKoinaModel(prosit2019, input)

}
\seealso{
\url{https://koina.wilhelmlab.org}
}
